; Texturing with bilinear filtering, real Phongs shading
; and glass like effect (variable slices buffer for object)
; parallel. Implemented in FASM by Maciej Guba.
;
; Thanks to many authors of tutorials and aricles
; released in internet. Without them this proc wouldnt arise.



ROUND2 equ 10

glass_tex_tri_sl_var:
;----Procedure render Phongs shaded triangle with z coord
;----interpolation ( Catmull alghoritm ), each pixel is -
;----covered by texture using bilinear filtering. Also --
;----some depth independent, transparency effect occur in
;----this proc. I normalize normal vector in every pixel
;--------------in - eax - x1 shl 16 + y1 ----------------
;------------------ ebx - x2 shl 16 + y2 ----------------
;------------------ ecx - x3 shl 16 + y3 ----------------
;------------------ esi - pointer to slices ptr buffer---
;------------------  Every ptr points on depth history --
;------------------  of pixel, if ptr=0 -> background ---
;------------------  color, no depth history.------------
;------------------ edi - pointer to screen buffer-------
;------------------ edx - pointer to texture-------------
;------------------ xmm0 - 1st normal vector ------------
;------------------ xmm1 - 2cond normal vector ----------
;------------------ xmm2 - 3rd normal vector ------------
;------------------ xmm3 - normalized light vector ------
;------------------ xmm4 - lo -> hi z1, z2, z3 coords----
;------------------  as dwords floats -------------------
;------------------ xmm5 - lo -> hi y_min, y_max, -------
;------------------  x_min, x_max as dword integers -----
;------------------ xmm6 - lo -> hi tx1, ty1, tx2, ------
;------------------  ty2, tx3, ty3 as word, xres as------
;------------------  dword integers----------------------
;------------------ xmm7 - pointer to slices count buffer
;------------------ stack - no parameters ---------------
;--------------------------------------------------------
;------------- procedure don't save registers !! --------




  push	ebp
  mov	ebp,esp
  sub	esp,512
  sub	ebp,16
  and	ebp,0xfffffff0

  .gtsv_1_nv equ [ebp-16]
  .gtsv_2_nv equ [ebp-32]
  .gtsv_3_nv equ [ebp-48]
  .gtsv_l_v  equ [ebp-64]
  .gtsv_z3   equ [ebp-72]
  .gtsv_z2   equ [ebp-76]
  .gtsv_z1   equ [ebp-80]
  .gtsv_x1   equ [ebp-82]
  .gtsv_y1   equ [ebp-84]
  .gtsv_x2   equ [ebp-86]
  .gtsv_y2   equ [ebp-88]
  .gtsv_x3   equ [ebp-90]
  .gtsv_y3   equ [ebp-92]
  .gtsv_ptrs_ptr equ [ebp-96]	 ; stencil (slices) buff
  .gtsv_x_max	 equ  [ebp-100]
  .gtsv_x_min	 equ  [ebp-104]
  .gtsv_y_max	 equ  [ebp-108]
  .gtsv_y_min	 equ  [ebp-112]
  .gtsv_screen equ [ebp-116]
  .gtsv_dx12   equ [ebp-120]
  .gtsv_dx13   equ [ebp-124]
  .gtsv_dx23   equ [ebp-128]
  .gtsv_dn12   equ [ebp-144]
  .gtsv_dn13   equ [ebp-160]
  .gtsv_dn23   equ [ebp-176]

  .gtsv_cnv1   equ [ebp-192]  ; cur normal vectors
  .gtsv_cnv2   equ [ebp-208]
  .gtsv_x_res  equ [ebp-212]
  .gtsv_ty3    equ [ebp-214]
  .gtsv_tx3    equ [ebp-216]
  .gtsv_ty2    equ [ebp-218]
  .gtsv_tx2    equ [ebp-220]
  .gtsv_ty1    equ [ebp-222]
  .gtsv_tx1    equ [ebp-224]
  .gtsv_dz12   equ [ebp-232]
  .gtsv_dty12  equ [ebp-236]
  .gtsv_dtx12  equ [ebp-240]
  .gtsv_dz13   equ [ebp-248]
  .gtsv_dty13  equ [ebp-252]
  .gtsv_dtx13  equ [ebp-256]
  .gtsv_dz23   equ [ebp-264]
  .gtsv_dty23  equ [ebp-268]
  .gtsv_dtx23  equ [ebp-272]
  .gtsv_cz1    equ [ebp-280]
  .gtsv_cty1   equ [ebp-284]
  .gtsv_ctx1   equ [ebp-288]
  .gtsv_cz2    equ [ebp-296]
  .gtsv_cty2   equ [ebp-300]
  .gtsv_ctx2   equ [ebp-304]
  .gtsv_tx_ptr equ [ebp-308]
  .gtsv_cnt_ptr equ [ebp-312]


      emms
    ;  movd    .x_res,xmm7
 .gtsv_sort3:		       ; sort triangle coordinates...
       cmp     ax,bx
       jle     .gtsv_sort1
       xchg    eax,ebx
       shufps  xmm4,xmm4,11100001b
       shufps  xmm6,xmm6,11100001b
       movaps  xmm7,xmm0
       movaps  xmm0,xmm1
       movaps  xmm1,xmm7


 .gtsv_sort1:
       cmp	bx,cx
       jle	.gtsv_sort2
       xchg	ebx,ecx
       shufps	xmm4,xmm4,11011000b
       shufps	xmm6,xmm6,11011000b
       movaps	xmm7,xmm1
       movaps	xmm1,xmm2
       movaps	xmm2,xmm7

       jmp .gtsv_sort3

 .gtsv_sort2:
    movss  .gtsv_cnt_ptr,xmm7
    movaps .gtsv_tx1,xmm6
    movaps .gtsv_z1,xmm4
    mov    .gtsv_y1,eax
    mov    .gtsv_y2,ebx
    mov    .gtsv_y3,ecx

    movdqa   .gtsv_y_min,xmm5
if 1				; check if at last only fragment
   packssdw xmm5,xmm5	    ; of triangle is in visable area
   pshuflw  xmm5,xmm5,11011000b
   movdqu   xmm7,.gtsv_y3
   movdqa   xmm6,xmm5
   pshufd   xmm5,xmm5,0  ; xmm5 lo-hi -> broadcasted y_min, x_min
   pshufd   xmm6,xmm6,01010101b ;xmm6 -> brd y_max x_max
   movdqa   xmm4,xmm7
   pcmpgtw  xmm7,xmm5
   pcmpgtw  xmm4,xmm6
   pxor     xmm7,xmm4
   pmovmskb eax,xmm7
   and	    eax,0x00aaaaaa
   or	    eax,eax
   jz	    .gtsv_rpt_loop2_end
end if
   movaps   .gtsv_1_nv,xmm0
   movaps   .gtsv_2_nv,xmm1
   movaps   .gtsv_3_nv,xmm2
   movaps   .gtsv_l_v,xmm3
   mov	    .gtsv_ptrs_ptr,esi
   mov	    .gtsv_screen,edi
   mov	    .gtsv_tx_ptr,edx



       mov	bx,.gtsv_y2	  ; calc deltas
       sub	bx,.gtsv_y1
       jnz	.gtsv_rpt_dx12_make

       xorps	xmm7,xmm7
       mov	dword .gtsv_dx12,0
       movaps	.gtsv_dtx12,xmm7
       movaps	.gtsv_dn12,xmm7
       jmp	.gtsv_rpt_dx12_done

  .gtsv_rpt_dx12_make:
       mov	ax,.gtsv_x2
       sub	ax,.gtsv_x1
       cwde
       movsx	ebx,bx
       shl	eax,ROUND2
       cdq
       idiv	ebx
       mov	.gtsv_dx12,eax

       cvtsi2ss xmm6,ebx
       shufps	xmm6,xmm6,0
       movss	xmm5,.gtsv_z2
       subss	xmm5,.gtsv_z1
       divss	xmm5,xmm6
       movss	.gtsv_dz12,xmm5

       movd	xmm0,.gtsv_tx1
       movd	xmm2,.gtsv_tx2
       pxor	xmm1,xmm1
       punpcklwd xmm0,xmm1
       punpcklwd xmm2,xmm1
       psubd	 xmm2,xmm0
       cvtdq2ps xmm2,xmm2
       divps	xmm2,xmm6
       movlps	.gtsv_dtx12,xmm2

       movaps	xmm0,.gtsv_2_nv
       subps	xmm0,.gtsv_1_nv
       divps	xmm0,xmm6
       movaps	.gtsv_dn12,xmm0


   .gtsv_rpt_dx12_done:

       mov	bx,.gtsv_y3	  ; calc deltas
       sub	bx,.gtsv_y1
       jnz	.gtsv_rpt_dx13_make

       xorps	xmm7,xmm7
       mov	dword .gtsv_dx13,0
       movaps	.gtsv_dtx13,xmm7
       movaps	.gtsv_dn13,xmm7
       jmp	.gtsv_rpt_dx13_done

  .gtsv_rpt_dx13_make:
       mov	ax,.gtsv_x3
       sub	ax,.gtsv_x1
       cwde
       movsx	ebx,bx
       shl	eax,ROUND2
       cdq
       idiv	ebx
       mov	.gtsv_dx13,eax


       cvtsi2ss xmm6,ebx
       shufps	xmm6,xmm6,0

       movss	xmm5,.gtsv_z3
       subss	xmm5,.gtsv_z1
       divss	xmm5,xmm6
       movss	.gtsv_dz13,xmm5

       movd	xmm0,.gtsv_tx1
       movd	xmm2,.gtsv_tx3
       pxor	xmm1,xmm1
       punpcklwd xmm0,xmm1
       punpcklwd xmm2,xmm1
       psubd	xmm2,xmm0
       cvtdq2ps xmm2,xmm2
       divps	xmm2,xmm6
       movlps	.gtsv_dtx13,xmm2



       movaps	xmm0,.gtsv_3_nv
       subps	xmm0,.gtsv_1_nv
       divps	xmm0,xmm6
       movaps	.gtsv_dn13,xmm0

   .gtsv_rpt_dx13_done:

       mov	bx,.gtsv_y3	  ; calc deltas
       sub	bx,.gtsv_y2
       jnz	.gtsv_rpt_dx23_make

       xorps	xmm7,xmm7
       mov	dword .gtsv_dx23,0
       movaps	.gtsv_dtx23,xmm7
       movaps	.gtsv_dn23,xmm7
       jmp	.gtsv_rpt_dx23_done

  .gtsv_rpt_dx23_make:
       mov	ax,.gtsv_x3
       sub	ax,.gtsv_x2
       cwde
       movsx	ebx,bx
       shl	eax,ROUND2
       cdq
       idiv	ebx
       mov	.gtsv_dx23,eax

       cvtsi2ss xmm6,ebx
       shufps	xmm6,xmm6,0
       movss	xmm5,.gtsv_z3
       subss	xmm5,.gtsv_z2
       divss	xmm5,xmm6
       movss	.gtsv_dz23,xmm5

       movd	xmm0,.gtsv_tx2
       movd	xmm2,.gtsv_tx3
       pxor	xmm1,xmm1
       punpcklwd xmm0,xmm1
       punpcklwd xmm2,xmm1
       psubd	 xmm2,xmm0
       cvtdq2ps xmm2,xmm2
       divps	xmm2,xmm6
       movlps	.gtsv_dtx23,xmm2




       movaps	xmm0,.gtsv_3_nv
       subps	xmm0,.gtsv_2_nv
       divps	xmm0,xmm6
       movaps	.gtsv_dn23,xmm0

   .gtsv_rpt_dx23_done:

       movsx   eax,word .gtsv_x1
       shl     eax,ROUND2
       mov     ebx,eax
       mov     edx,.gtsv_z1
       movd    xmm1,.gtsv_tx1
       pxor    xmm2,xmm2
       punpcklwd xmm1,xmm2
       cvtdq2ps  xmm1,xmm1

       mov     .gtsv_cz1,edx
       mov     .gtsv_cz2,edx
       movaps  xmm0,.gtsv_1_nv
       movlps  .gtsv_ctx1,xmm1
       movlps  .gtsv_ctx2,xmm1
       movaps  .gtsv_cnv1,xmm0
       movaps  .gtsv_cnv2,xmm0

     ;	mov	edx,.dx13
     ;	cmp	edx,.dx12
     ;	jg	.second_cause

       movsx	ecx,word .gtsv_y1
       cmp	cx,.gtsv_y2

       jge	.gtsv_rpt_loop1_end

    .gtsv_rpt_loop1:
       pushad

       movaps	xmm2,.gtsv_y_min
       movaps	xmm0,.gtsv_cnv1
       movaps	xmm1,.gtsv_cnv2
    ;	movlps	 xmm3,.gtsv_cz1 ; cz1, cz2 both
       movaps	xmm3,.gtsv_ctx1
       movaps	xmm5,.gtsv_ctx2
       movaps	xmm4,.gtsv_l_v
       movd	xmm6,.gtsv_x_res
       movd	xmm7,.gtsv_cnt_ptr
       sar	ebx,ROUND2
       sar	eax,ROUND2
       mov	edx,.gtsv_tx_ptr
       mov	edi,.gtsv_screen

       mov	esi,.gtsv_ptrs_ptr

       call	glass_tex_line_sl_var

       popad
       movaps	xmm0,.gtsv_cnv1
       movaps	xmm1,.gtsv_cnv2
       movaps	xmm2,.gtsv_ctx1
       movaps	xmm3,.gtsv_ctx2
       addps	xmm0,.gtsv_dn13
       addps	xmm1,.gtsv_dn12
       addps	xmm2,.gtsv_dtx13
       addps	xmm3,.gtsv_dtx12
       add	eax,.gtsv_dx13
       add	ebx,.gtsv_dx12

       movaps	.gtsv_cnv1,xmm0
       movaps	.gtsv_cnv2,xmm1
       movaps	.gtsv_ctx1,xmm2
       movaps	.gtsv_ctx2,xmm3
       add	ecx,1
       cmp	cx,.gtsv_y2
       jl	.gtsv_rpt_loop1


   .gtsv_rpt_loop1_end:
       movsx	ecx,word .gtsv_y2
       cmp	cx,.gtsv_y3
       jge	.gtsv_rpt_loop2_end

       movsx	ebx,word .gtsv_x2	    ; eax - cur x1
       shl	ebx,ROUND2	       ; ebx - cur x2
       push	dword .gtsv_z2
       pop	dword .gtsv_cz2
       movd	xmm1,.gtsv_tx2
       pxor	xmm2,xmm2
       punpcklwd xmm1,xmm2
       cvtdq2ps xmm1,xmm1
       movlps	.gtsv_ctx2,xmm1
       movaps	xmm0,.gtsv_2_nv
       movaps	.gtsv_cnv2,xmm0


     .gtsv_rpt_loop2:
       pushad

       movaps	xmm2,.gtsv_y_min
       movaps	xmm0,.gtsv_cnv1
       movaps	xmm1,.gtsv_cnv2
       movaps	xmm3,.gtsv_ctx1
       movaps	xmm5,.gtsv_ctx2
       movaps	xmm4,.gtsv_l_v
       sar	ebx,ROUND2
       sar	eax,ROUND2
       mov	edx,.gtsv_tx_ptr
       mov	edi,.gtsv_screen
       mov	esi,.gtsv_ptrs_ptr
       movd	xmm6,.gtsv_x_res
       movd	xmm7,.gtsv_cnt_ptr
       call	glass_tex_line_sl_var

       popad
       movaps	xmm0,.gtsv_cnv1
       movaps	xmm1,.gtsv_cnv2
       movaps	xmm2,.gtsv_ctx1
       movaps	xmm3,.gtsv_ctx2
       addps	xmm0,.gtsv_dn13
       addps	xmm1,.gtsv_dn23
       addps	xmm2,.gtsv_dtx13
       addps	xmm3,.gtsv_dtx23

       add	eax,.gtsv_dx13
       add	ebx,.gtsv_dx23

       movaps	.gtsv_cnv1,xmm0
       movaps	.gtsv_cnv2,xmm1
       movaps	.gtsv_ctx1,xmm2
       movaps	.gtsv_ctx2,xmm3


       add	ecx,1
       cmp	cx,.gtsv_y3
       jl	.gtsv_rpt_loop2

    .gtsv_second_cause:  ;dx13 > dx12

    .gtsv_rpt_loop2_end:

      add   esp,512
      pop   ebp

ret
align 16
glass_tex_line_sl_var:
; in:
;    xmm0 - normal vector 1
;    xmm1 - normal vect 2
;    xmm3 - lo -> hi tx1, ty1, z1 coords as dwords float
;    xmm5 - lo -> hi tx2, ty2, z2 coords as dwords float
;    xmm2 - lo -> hi y_min, y_max, x_min, x_max
;	    as dword integers
;    xmm4 - normalized light vector ;;; unused now
;    xmm7 - cnt_ptr
;    eax - x1
;    ebx - x2
;    ecx - y
;    edi - screen buffer
;    esi - pointer of pointers to slices buffer
;    edx - texture pointer (handle)
;    xmm6 - lowest dword x_res as integer

   push  ebp
   mov	 ebp,esp
   sub	 esp,350
   sub	 ebp,16
   and	 ebp,0xfffffff0

 .gtsvl_n1 equ [ebp-16]
 .gtsvl_n2 equ [ebp-32]
 .lv equ [ebp-48]
 .gtsvl_x1 equ [ebp-52]
 .gtsvl_x2 equ [ebp-56]
; .z2 equ [ebp-60]
; .z1 equ [ebp-64]
 .gtsvl_screen equ [ebp-68]
 .gtsvl_zbuff  equ [ebp-72]
 .gtsvl_x_max  equ [ebp-74]
 .gtsvl_x_min  equ [ebp-76]
 .gtsvl_y_max  equ [ebp-78]
 .gtsvl_y_min  equ [ebp-80]
 .gtsvl_dn     equ [ebp-96]
 .gtsvl_x_res  equ [ebp-100]
 .ylvs	 equ [ebp-104]
 .gtsvl_cnv    equ [ebp-128]
 .gtsvl_z1     equ [ebp-136]
 .gtsvl_ty1    equ [ebp-140]
 .gtsvl_tx1    equ [ebp-144]
 .gtsvl_z2     equ [ebp-152]
 .gtsvl_ty2    equ [ebp-156]
 .gtsvl_tx2    equ [ebp-160]
 .gtsvl_cz     equ [ebp-168]
 .gtsvl_cty    equ [ebp-172]
 .gtsvl_ctx    equ [ebp-176]
 .gtsvl_dz     equ [ebp-184]
 .gtsvl_dty    equ [ebp-188]
 .gtsvl_dtx    equ [ebp-192]
 .gtsvl_yd     equ [ebp-196]
 .gtsvl_xd     equ [ebp-200]
 .gtsvl_yf     equ [ebp-204]
 .gtsvl_xf     equ [ebp-208]
 .gtsvl_w4     equ [ebp-212]
 .gtsvl_w3     equ [ebp-216]
 .gtsvl_w2     equ [ebp-220]
 .gtsvl_w1     equ [ebp-224]
 .gtsvl_p4     equ [ebp-228]
 .gtsvl_p3     equ [ebp-232]
 .gtsvl_p2     equ [ebp-236]
 .gtsvl_p1     equ [ebp-240]


 .gtsvl_tx_ptr	   equ [ebp-244]
 .gtsvl_cnt_ptr    equ dword[ebp-248]
 .gtsvl_ptrs_ptr   equ dword[ebp-252]
 .gtsvl_sl_c	   equ dword[ebp-256]



	cmp    ecx,0
	jle    .end_line
	cmp    cx,[xres_var]
	jge    .end_line
	mov    .ylvs,ecx
	packssdw xmm2,xmm2
	movq   .gtsvl_y_min,xmm2
	cmp    cx,.gtsvl_y_min
	jl     .end_line
	cmp    cx,.gtsvl_y_max
	jge    .end_line	  ;
	movd   .gtsvl_cnt_ptr,xmm7
	cmp	eax,ebx
	je	.end_line
	jl	@f
	xchg	eax,ebx
	movaps	xmm7,xmm0
	movaps	xmm0,xmm1
	movaps	xmm1,xmm7
	movaps	xmm7,xmm3
	movaps	xmm3,xmm5
	movaps	xmm5,xmm7
   @@:

	cmp	ax,.gtsvl_x_max
	jge	.end_line
	cmp	bx,.gtsvl_x_min
	jle	.end_line
	movaps	.lv,xmm4
	movaps	.gtsvl_n1,xmm0
	movaps	.gtsvl_n2,xmm1
	mov	.gtsvl_x1,eax
	mov	.gtsvl_x2,ebx
	movaps	.gtsvl_tx1,xmm3
	movaps	.gtsvl_tx2,xmm5
	movd	.gtsvl_x_res,xmm6
	mov	.gtsvl_tx_ptr,edx
	mov	.gtsvl_ptrs_ptr,esi
	sub	ebx,eax
	cvtsi2ss xmm7,ebx
	shufps	xmm7,xmm7,0
	subps	xmm1,xmm0
	divps	xmm1,xmm7
	movaps	.gtsvl_dn,xmm1
	subps	xmm5,xmm3
	divps	xmm5,xmm7
	movaps	.gtsvl_dtx,xmm5



	mov	 ebx,.gtsvl_x1
	cmp	 bx,.gtsvl_x_min     ; clipping on function4
	jge	 @f
	movzx	 eax,word .gtsvl_x_min
	sub	 eax,ebx
	cvtsi2ss xmm7,eax
	shufps	 xmm7,xmm7,0
	mulps	 xmm5,xmm7
	mulps	 xmm1,xmm7
	addps	 xmm5,.gtsvl_tx1
	addps	 xmm1,.gtsvl_n1
	movsx	 eax,word .gtsvl_x_min
	movaps	 .gtsvl_tx1,xmm5
	movaps	 .gtsvl_n1,xmm1
	mov	 dword .gtsvl_x1,eax

      @@:
	movzx	eax,word .gtsvl_x_max
	cmp	.gtsvl_x2,eax
	jl	@f
	mov	.gtsvl_x2,eax
      @@:
	mov	eax,.gtsvl_x_res
	imul	eax, dword .ylvs
	add	eax,.gtsvl_x1
     ;	 int3
	push	[slices_counter_ptr]  ;;  debug
	pop	.gtsvl_cnt_ptr		    ;;	debug
	add	.gtsvl_cnt_ptr,eax
     ;	 push	 .cnt_ptr
     ;	 pop	 esi
	mov	esi,.gtsvl_ptrs_ptr
     ;	 mov	 esi,[slices_ptrs_buff_ptr]  ;; debug
	shl	eax,2
	add	edi,eax
  ;	 shl	 eax,2
	add	esi,eax

	mov	ecx,.gtsvl_x2
	sub	ecx,.gtsvl_x1
	movaps	xmm2,.gtsvl_tx1
align 16
   .ddraw:
;	 int3
	push	  ecx
	   ;variable slices
	mov	  ecx,.gtsvl_cnt_ptr
	movzx	  ecx,byte [ecx]
	or	  ecx,ecx
	jz	  .skip
	xor	  eax,eax
	mov	  edx,[esi]
      ;  mov	   edx,[edx]
	or	  edx,edx
	jz	  .skip
     @@:
	movaps	  xmm3,xmm2
	shufps	  xmm3,xmm3,10101010b
	movaps	  xmm0,xmm3
	addps	  xmm3,[aprox]
	subps	  xmm0,[aprox]
	cmpnltss  xmm0,[edx]
	cmpnltss  xmm3,[edx]
	xorps	  xmm0,xmm3
      ;  pmovmskb  ebx,xmm0
	movd	  ebx,xmm0
	cmp	  ebx,-1
	je	  @f
	add	  eax,1
	cmp	  eax,10 ;visable max to 10 slices
	je	  .skip
	cmp	  eax,ecx
	je	  @f
	add	  edx,4
	jmp	  @b
      @@:
	movzx	 eax,al
	mov	 .gtsvl_sl_c,eax
	; normal
	xorps	 xmm5,xmm5
	movaps	 xmm7,.gtsvl_n1  ;xmm0
	mulps	 xmm7,xmm7 ; normalize
	haddps	 xmm7,xmm7
	haddps	 xmm7,xmm7
	rsqrtps  xmm7,xmm7
	mulps	 xmm7,.gtsvl_n1   ;xmm0
 ;	 andps	  xmm7,[abs_z_coof]
	movaps	 .gtsvl_cnv,xmm7

	movaps	 xmm6,xmm2
	minps	 xmm6,[tex_m2]	;    float  TEX_X-2,TEX_Y-2
	cvttps2dq xmm7,xmm6
	cvtdq2ps xmm4,xmm7
	subps	 xmm6,xmm4
	movlps	 .gtsvl_xf,xmm6
     ;	  movaps   xmm5,.lv

	mov	 eax,lights_aligned   ; global
      align 16
      .again_col:
	movaps	 xmm0,[eax] ; calc multple lights
	mulps	 xmm0,.gtsvl_cnv  ;.lv	; last dword should be zeroed
	haddps	 xmm0,xmm0
	haddps	 xmm0,xmm0
	xorps	  xmm4,xmm4
   ;	 andps	  xmm0,[abs_val]  ;calc absolute value

	cmp	  .gtsvl_sl_c,0
	jne	  .no_reflective

	movaps	  xmm4,xmm0 ; reflective particle of light equation
	mulps	  xmm4,xmm4 ; only for first front slice.
	mulps	  xmm4,xmm4
	mulps	  xmm4,xmm4
	mulps	  xmm4,xmm4
	mulps	  xmm4,[eax+48]

     .no_reflective:
	maxps	 xmm0,[the_zero]
 ;	 movaps   xmm1,xmm0
	mulps	 xmm0,[eax+16]
	addps	 xmm4,xmm0
	addps	 xmm4,[eax+32]
	maxps	 xmm5,xmm4
	add	 eax,64
	cmp	 eax,lights_aligned_end
	jnz	 .again_col
	minps	 xmm5,[mask_255f]

	  ; texture coords work
	movd	 eax,xmm7
	psrldq	 xmm7,4
	movd	 ebx,xmm7
	shl	 ebx,TEX_SHIFT
	add	 eax,ebx
	shl	 eax,2
	add	 eax,.gtsvl_tx_ptr
	mov	 ebx,eax
	add	 ebx,TEX_X*4
	movd	 xmm7,[eax]
	movd	 xmm6,[eax+4]
	movd	 xmm4,[ebx]
	movd	 xmm3,[ebx+4]
	punpcklbw xmm7,xmm6 ;xmm7 r1 r2 g1 g2 b1 b2
	punpcklbw xmm4,xmm3 ;xmm4 r3 r4 g3 g4 b3 b4
	punpcklwd xmm7,xmm4 ;xmm7 r1 r2 r3 r4 g1 g2 g3 g4 ...
	movdqa	  xmm6,xmm7
	movdqa	  xmm4,xmm7
	psrldq	  xmm6,4
	psrldq	  xmm4,8

	punpcklbw xmm7,[the_zero]  ; broadcasted 0
	punpcklbw xmm6,[the_zero]
	punpcklbw xmm4,[the_zero]
	punpcklwd xmm7,[the_zero]
	punpcklwd xmm6,[the_zero]
	punpcklwd xmm4,[the_zero]


     ; calc w .........
	movlps	 xmm3,[the_one]  ;  broadcasted dword 1.0
	cvtdq2ps  xmm7,xmm7
	subps	 xmm3,.gtsvl_xf
	cvtdq2ps  xmm6,xmm6
	movhps	 xmm3,.gtsvl_xf
	cvtdq2ps  xmm4,xmm4
	movaps	 xmm1,xmm3  ; 1-xf, 1-yf, xf, yf
	shufps	 xmm3,xmm3,10001000b
	shufps	 xmm1,xmm1,11110101b
	mulps	 xmm3,xmm1

	mulps	 xmm7,xmm3
	mulps	 xmm6,xmm3
	mulps	 xmm4,xmm3
	haddps	 xmm7,xmm7  ; r
	haddps	 xmm6,xmm6  ; g
	haddps	 xmm4,xmm4  ; b
	haddps	 xmm7,xmm7  ; r
	haddps	 xmm6,xmm6  ; g
	haddps	 xmm4,xmm4  ; b
	movlhps  xmm7,xmm6
	shufps	 xmm7,xmm7,11101000b
	movlhps  xmm7,xmm4

	mulps	  xmm5,xmm7

	sub	  .gtsvl_sl_c,10
	neg	  .gtsvl_sl_c
	cvtsi2ss  xmm0,.gtsvl_sl_c
	mulss	  xmm0,[peeling_particle]
	shufps	  xmm0,xmm0,0
	mulps	  xmm5,xmm0
     .final:

	minps	  xmm5,[word_max_f]
	cvtps2dq  xmm5,xmm5
	psrld	  xmm5,8
	movd	  xmm6,[edi]
	packssdw  xmm5,xmm5
	packuswb  xmm5,xmm5
	paddusb   xmm5,xmm6
	movd	  [edi],xmm5
      .skip:
	add	 edi,4
	add	 esi,4
	add	 .gtsvl_cnt_ptr,1
	movaps	 xmm0,.gtsvl_n1     ; cur normal
	addps	 xmm0,.gtsvl_dn
	addps	 xmm2,.gtsvl_dtx
	movaps	 .gtsvl_n1,xmm0
	pop	 ecx
	sub	 ecx,1
	jnz	 .ddraw

  .end_line:
	add	 esp,350
	pop	 ebp

ret
