delete_chunk:
; in eax - chunks No to delete
; Need perform remove dead triangles and remove
; unused vertices at the end of process.
  mov    esi,[chunks_ptr]
  mov    ecx,[triangles_count_var]
  mov    edi,[triangles_ptr]
  pxor   xmm0,xmm0
 .nxx:
  cmp    [esi],ax
  jne    @f
  movq   [edi],xmm0
  movd   [edi+8],xmm0
 @@:
  add    esi,2
  add    edi,12
  loop   .nxx
ret

;============================================================

invert_normals_ch:
; invert sense of normal vectors of selected chunk;
; in eax - index number of selected chunk

  mov    esi,[chunks_ptr]
  mov    ecx,[triangles_count_var]
  mov    edi,[triangles_ptr]
 .nxx:
  cmp    [esi],ax
  jne    @f
  movq   xmm0,[edi]
  pshufd xmm0,xmm0,11100001b
  movq   [edi],xmm0
 @@:
  add    esi,2
  add    edi,12
  loop   .nxx
ret

;=========================================================================
detect_chunks:
; make pivot table, sort, remove unused vertices, find chunks...
; in  - some global variables and
;   eax = 0 or 1 - export or non export some lists
;   ebx = 0x33333333  -> make only pivot table
;   ebx = 0x44444444  -> check if rmove unused vert must
;                         be done
; out:
; if eax = 0
;      ebx - chunks list ptr
;      ecx - chunks number
; if eax = 1 above and -
;      esi - tri_ch    ; vertices with triangles list
;      edi - t_ptr     ; pointers to tri_ch list

    push ebp
    mov  ebp,esp
    sub  esp,68


   .tri_ch         equ  dword[ebp-4]    ; tri chunks list ptr
   .chunks         equ  dword[ebp-8]    ; chunks ptreach tri chunk No. as word
   .endt           equ  dword[ebp-12]   ;
   .t_ptr          equ  dword[ebp-16]   ; pointers list
   .tri_ch1        equ  dword[ebp-20]   ;
   .up             equ  dword[ebp-24]   ; upload ptr
   .chmr           equ  dword[ebp-28]   ; bit mark list if tri stored
   .str            equ  dword[ebp-32]   ; store ptr
   .ltch1          equ  dword[ebp-36]   ; end of tri_ch1 ptr
   .ch_cnt         equ  dword[ebp-40]
   .cntt           equ  dword[ebp-44]
   .cc             equ  dword[ebp-48]
   .lsparam        equ  dword[ebp-52]
   .fix_mark       equ  dword[ebp-56]
   .endVptr        equ  dword[ebp-60]
   .pivot          equ  dword[ebp-64]
   .old_esp        equ  dword[ebp-68]

   prompt  prompt_det_chunks ; macro
   mov     .lsparam,eax
   mov     .pivot,ebx

;   push    [triangles_count_var]
   call    remove_dead_tri
;   pop     eax

    mov     .fix_mark,0
;   cmp     eax,[triangles_count_var]
;   je      @f
;   mov     .fix_mark,1 ; do rm unused vert perhaps do it always
; @@:


   mov     ebx,[triangles_count_var]
   shl     ebx,3
   lea     ebx,[ebx*3]
   add     ebx,65536
   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .tri_ch,eax

;   mov     ebx,[points_count_var]
;   shr     ebx,3
;   add     ebx,100
;   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
;   or      eax,eax
;   jnz     @f
 ;  invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
;  @@:
;   mov     .mark_un_vert,eax



   mov     ebx,[triangles_count_var]
   lea     ebx,[ebx*3]
   shl     ebx,3
   add     ebx,65536
   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .tri_ch1,eax



   mov     ebx,[points_count_var]
   shl     ebx,2
   add     ebx,1120
   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .t_ptr,eax

   cmp    .pivot,0x33333333
   je     .no_a

   mov     ebx,[triangles_count_var]
   shl     ebx,1
   add     ebx,20
   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .chunks,eax     ; each tri chunk No. as word

   mov     ebx,[triangles_count_var]
   shr     ebx,3
   add     ebx,20
   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .chmr,eax     ; chunks mark if bit is set - tri was used





; .ag: ; again
;   mov     .fix_mark,0
 .ag:

   call    remove_dead_tri

   mov     edi,.chmr
   pxor    xmm0,xmm0
   mov     ecx,[triangles_count_var]
   shr     ecx,7
   inc     ecx
 @@:
   movdqa  [edi],xmm0
   add     edi,16
   loop    @b

 .no_a:


   mov    eax,[points_count_var]
   imul   eax,[i12]
   add    eax,[points_r_ptr]
   mov    .endVptr,eax

; make pivot table

   mov       edi,.tri_ch
   mov       esi,[triangles_ptr]
   xor       ecx,ecx
  @@:
   movd      xmm1,ecx
   movq      xmm0,[esi]
   pshufd    xmm1,xmm1,0
   movd      xmm2,[esi+8]
   punpckldq xmm0,xmm1
   punpckldq xmm2,xmm1
   movdqu   [edi],xmm0
   movq     [edi+16],xmm2
   add       esi,12
   add       edi,24
   inc       ecx
   cmp       ecx,[triangles_count_var]
   jnz       @b

; qsort


   mov      esi,.tri_ch
   mov      edi,.tri_ch1
   mov      ecx,[triangles_count_var]
   lea      ecx,[ecx*3]
   call     sort_hybrid1
;   call     mix_tab



   mov    ecx,[triangles_count_var]
   lea    ecx,[ecx*3]

   mov    esi,ecx
   shl    esi,3
   add    esi,.tri_ch
   mov   .endt,esi

;check if remove unused vert must be done
  mov    esi,.tri_ch
  cld
 .ptC:
  lodsd
    ; esi - vert index
  add     esi,4
; .ptCff:
  cmp     esi,.endt
  jae     .dnC
  cmp    eax,[esi]
  je     .ptC
  lea    ebx,[eax+1]
  cmp    ebx,[esi]
  je     .ptC
       ; check done





 .movt:

;  sub   esi,32
;  dbg_ptr  esi
;  add      esi,32


  push    esi
  movd    xmm7,ebx      ; vert index + 1
  mov     edi,[esi]     ; edi - ver index
  sub     edi,ebx
  movd    xmm6,edi

 @@:
  cmp     esi,.endt
  jnb     @f
  sub     [esi],edi    ; fix .tri_ch pivot table list
  add     esi,8
  jmp     @b
 @@:


  ;shrink vert
  lea     ebx,[ebx*3]
  shl     ebx,2
  add     ebx,[points_r_ptr]
  imul    edi,[i12]
  add     edi,ebx

  cmp     edi,.endVptr           ; fix points_r  list
  ja      .dnV
 @@:
  movq    xmm0,[edi]
  movd    xmm1,[edi+8]
  movq    [ebx],xmm0
  movd    [ebx+8],xmm1
  add     edi,12
  add     ebx,12
  cmp     edi,.endVptr           ; fix point_r  list
  jna     @b

 .dnV:

; recalc tri  all indices above ebx - sub edi
;  push   ecx

  mov    esi,[triangles_ptr]
  mov    ecx,[triangles_count_var]
  lea    ecx,[ecx*3]
  movd   edi,xmm6
  movd   ebx,xmm7
 .agT:
  cmp    [esi],ebx  ; eax
  jb     @f
  sub    [esi],edi
 @@:
  add   esi,4
  loop  .agT


  pop    esi
;  sub      esi,32
;  dbg_ptr  esi
;  add      esi,32

;  add   .fix_mark,edi     ; at last one vert was removed
  sub    [points_count_var],edi

;  sub    ecx,edi
;  dec    ecx   ; sub ???? / without any  ?

  jmp   .ptC  ;ff           ; again check sth found


 .dnC:      ; check done


;  cmp   .fix_mark,0
;  je    @f
;  int3
 @@:

;  jne    .ag

  .do_ch:


;make t_ptr  - table with pointers/adresses


  mov    ecx,[points_count_var]
  mov    esi,.tri_ch
  mov    edi,.t_ptr
  mov    ebx,ecx

  mov    [edi],esi
  add    edi,4
  dec    ecx
  jz     .dn
 .pt:
  mov    eax,[esi]        ; [esi]   - vert ind
  add    esi,8
  cmp    eax,[esi]        ; [esi+4] - tri ind
  je     @f
  mov    [edi],esi
  add    edi,4
  dec    ecx
  jz     .dn
 @@:
  cmp   esi,.endt
  jb    .pt
;  jmp    .pt

 .dn:

  cmp    .pivot,0x33333333
  je     .end2_piv


;  dbg_ptr  .t_ptr


   ; each dword position in .t_ptr list - adress of corresponding
   ; triangles indexes, each triangles from such index contains this vertice

  ; search for chunks
        mov     eax,[triangles_count_var]
        mov     .cntt,eax   ; temp help cnt
        xor     ecx,ecx
        mov     .cc,ecx
        mov     esi,[triangles_ptr]
        mov     edi,.tri_ch1
        imul    eax,[i12]
        shl     eax,3
        add     eax,edi
        mov     .ltch1,eax    ; last

        mov     .up,esi
        mov     .str,edi
    .lb1:
;        int3
     ;   mov     edi,.str  ;           ; nx chunk
        cmp     edi,.ltch1
        jnb     .endl          ;nb
  ;      mov     edi,.tri_ch1
        mov     .str,edi
        mov     eax,.cc
        mov     edx,.cc
        inc     .cc
        cmp     edx,[triangles_count_var]
        jz      .endl
        shr     eax,3
        and     edx,111b
        add     eax,.chmr

        xor     ebx,ebx
        bt      [eax],edx           ; mark
        jc      @f                  ; tri was stored
        inc     ecx
        or      ebx,1b
        mov     esi,.up
        movdqu  xmm0,[esi]
        movdqu  [edi],xmm0
        add     .str,12
;        add     .up,12
      @@:
        add     .up,12
        or      ebx,ebx
        jz      .lb1

    .lb2:
        mov     eax,[edi]
        mov     edx,[edi] ; edx - vert ind
        shl     eax,2
        add     eax,.t_ptr
        mov     eax,[eax]           ; [eax] -   t ptr
        or      eax,eax
        jz      .endl
    .nxt:

        mov     esi,[eax+4]
        mov     ebx,[eax+4]
        shr     esi,3
        and     ebx,111b
        add     esi,.chmr
        bts     [esi],ebx           ; mark
        jc      @f                  ; tri was stored
        dec     .cntt
        je      .endl
        mov     esi,[eax+4]         ; [eax+4] - tri ind
        add     esi,esi
        add     esi,.chunks
        mov     [esi],cx
        mov     esi,[eax+4]

        imul    esi,[i12]
        add     esi,[triangles_ptr]
        movups  xmm0,[esi]
        mov     esi,.str
        movups  [esi],xmm0
        add     .str,12
      @@:
        add     eax,8
        cmp     edx,[eax]
        je      .nxt
        add     edi,4

        cmp     edi,.str
        jne     .lb2
        jmp     .lb1

    .endl:

        mov     .ch_cnt,ecx

   ;     dbg_ptr  .tri_ch1

if 0
        mov     edi,.tri_ch1
        lea     esi,[edi+12]
        mov     ecx,[triangles_count_var]
   ;     lea     ecx,[ecx*3]
   ;     shr     ecx,2
   ;     inc     ecx
      @@:
        movups  xmm0,[esi]
        movaps  [edi],xmm0
        add     esi,16
        add     edi,16
        loop    @b
end if
   ;     dbg_ptr  .tri_ch1


  .end:
   cmp     .lsparam,1
   je      @f
   invoke  VirtualFree ,.t_ptr,0 , MEM_RELEASE
   invoke  VirtualFree ,.tri_ch,0 , MEM_RELEASE
 @@:

 ;  invoke  VirtualFree, .tri_ch1,0 , MEM_RELEASE      ;,0 , MEM_RELEASE   [triangles_ptr]
   invoke  VirtualFree ,.chmr,0 , MEM_RELEASE

  .end2_piv:   ;-piv:
   invoke  VirtualFree, .tri_ch1,0 , MEM_RELEASE

;   mov    eax,.tri_ch1

   mov    ebx,.chunks
   mov    ecx,.ch_cnt
;   mov    [triangles_ptr],eax

   mov  esi,.tri_ch
   mov  edi,.t_ptr

   cls    ; macro

   mov    esp,ebp
   pop    ebp
ret

if 0

optimize_object:
; in:
;    [chunks_ptr] - global chunk list
;    [triangles_ptr] - tris list
;    [points_r_ptr] - vertices list
;    [triangles_count_var] - tris count
;    [points_count_var] - verts count
;    [edges_number] - edges count
;    esi,edi - ptr to mem - both-> tris count * 24 in size

   .a_ptr equ dword[ebp-4]
   .b_ptr equ dword[ebp-8]
   .bas_index equ dword[ebp-12]  ; base ind in cur chunk
   .bas_tri   equ dword[ebp-16]
   .tri_cnt   equ dword[ebp-20]

    push        ebp
    mov         ebp,esp
    push        esi
    push        edi

    sub         esp,12

    mov     esi,[chunks_ptr]
    mov     ecx,[chunks_count]
  .ll:
    lodsw
    cmp     ax,[esi]
    je      @f
    inc     ax
    cmp     ax,[esi]
    jne     .do_opt
   @@:
    loop    .ll
    jmp     .end     ; optimization no needed, chunks in continous pieces
                     ; triangles list are correct, should vertices list be corrected ?


  .do_opt:
    xor     ecx,ecx
    mov     esi,[chunks_ptr]
    mov     edi,.a_ptr  ; make pivot table
    cld
   .l2:
    lodsw
    movzx   eax,ax
    stosd
    mov     eax,ecx
    stosd
    inc     ecx
    cmp     ecx,[triangles_count_var]
    jnz     .l2

 ;sort

   mov      esi,.a_ptr
   mov      edi,.b_ptr
   mov      ecx,[triangles_count_var]
   lea      ecx,[ecx*3]
   call     mix_tab

if 0
     dbg_ptr  .tri_ch

     mov   ebx,[triangles_count_var]
     lea   ebx,[ebx*3]
     shl   ebx,3
     sub   ebx,32*4+16
     add   ebx,.tri_ch
 ;    dbg_ptr ebx
end if


     movd    xmm5,esp

     mov     esp,.b_ptr
     mov     ebx,[triangles_count_var]
     lea     ebx,[ebx*3]
     shl     ebx,3
     add     esp,ebx

     mov     eax,1
     mov     ebx,[triangles_count_var]
     dec     ebx
     movd    xmm7,.a_ptr
     call    qsort_hybrid

     movd    esp,xmm5


if 0
     dbg_ptr .tri_ch

     mov   ebx,[triangles_count_var]
     lea   ebx,[ebx*3]
     shl   ebx,3
     sub   ebx,32*4+16
     add   ebx,.tri_ch
;     dbg_ptr ebx
end if


  ; renew tiriangles list
     mov     edi,.b_ptr           ;  make copy
     mov     esi,[triangles_ptr]
     mov     ecx,[triangles_count_var]
     lea     ecx,[ecx*3]
     shr     ecx,2
     inc     ecx
    @@:
     movdqa  xmm0,[esi]
     movdqa  [edi],xmm0
     add     esi,16
     add     edi,16
     loop    @b

     mov     esi,.a_ptr  ; pivot table adres
     mov     ecx,[triangles_count_var]
     mov     ebx,.b_ptr  ; old triangles list
     mov     edi,[triangles_ptr]
     add     esi,4       ; [esi+4]  - fresh tri position
    @@:                  ; make correct position of each tri
     lodsd
     lea     eax,[eax*3]
     shl     eax,2
     add     eax,edi
     movups  xmm0,[ebx]
     movlps  [eax],xmm0
     movhlps xmm0,xmm0
     movss   [eax+8],xmm0
     add     ebx,12
     add     esi,4
     loop    @b

 ; copy chunks list
     mov       esi,.a_ptr
     mov       edi,[chunks_ptr]
     mov       ecx,[triangles_count_var]
   @@:
     movsd
     stosw
     add       esi,4
     loop      @b

;  for each chunk, for each tri in chunk - find biggest and lowest
;  vert index, change lowest to base index -> (base is zero to chunk No. zero
;  and greatest_index+1 in previous chunk to chunks above chunk No. zero)
;  change-scale other indexes accoriding to lowest-base.








    mov     esi,[chunks_ptr]
    mov     ecx,[chunks_count]
    push    [triangles_ptr]
    pop     .bas_tri
    xor     ebx,ebx



    push    ecx


    xor     ecx,ecx
   @@:
    lodsw
    inc     ecx
    movzx   eax,ax
    cmp     [esi],ax
    je      @b

    ;  ecx - count of tris in chunk

    mov       .tri_cnt,ecx

    mov       esi,.bas_tri
    mov       edi,.b_ptr
    xor       ebx,ebx
  @@:
    movd      xmm2,ebx
    movq      xmm0,[esi]
    pshufd    xmm2,xmm2,0
    movd      xmm1,[esi+8]
    punpckldq xmm0,xmm2
    punpckldq xmm1,xmm2
    movdqu    [edi],xmm0
    movq      [edi+16],xmm1
    add       edi,24
    inc       ebx
    loop      @b


   mov      esi,.b_ptr
   mov      edi,.a_ptr
   mov      ecx,.tri_cnt
   lea      ecx,[ecx*3]
   call     mix_tab

if 0
     dbg_ptr  .tri_ch

     mov   ebx,[triangles_count_var]
     lea   ebx,[ebx*3]
     shl   ebx,3
     sub   ebx,32*4+16
     add   ebx,.tri_ch
 ;    dbg_ptr ebx
end if


     movd    xmm5,esp

     mov     esp,.a_ptr
     mov     ebx,[triangles_count_var]
     lea     ebx,[ebx*3]
     shl     ebx,3
     add     esp,ebx

     mov     eax,1
     mov     ebx,[triangles_count_var]
     dec     ebx
     movd    xmm7,.b_ptr
     call    qsort_hybrid

     movd    esp,xmm5


if 0
     dbg_ptr .tri_ch

     mov   ebx,[triangles_count_var]
     lea   ebx,[ebx*3]
     shl   ebx,3
     sub   ebx,32*4+16
     add   ebx,.tri_ch
;     dbg_ptr ebx
end if


;    .b_ptr - sorted list  -> first 4 bytes - vert index, next 4 bytes
;             tri index, this tri has this vert index at its content,
;             unit in .b_ptr ->  8 bytes

;     mov     edx,[triangles_count_var]
;     shl     edx,3
;     add     edx,16
;     add     edx,.a_ptr

     mov     ecx,[triangles_count_var]
     lea     ecx,[ecx*3]
     xor     ebx,ebx
     mov     edi,.a_ptr
     mov     esi,.b_ptr  ; count whole number of used unique indices
   .l4:
     mov     edx,esi
   .l3:
     lodsd
     add     esi,4
     cmp    [esi],eax
     je      @f
     inc     ebx
     stosd
     mov     eax,edx     ; ptr/adress to/of vert desc <=> v/t - ind
     stosd
     loop    .l4
     jmp     .enl
    @@:
     loop    .l3

    .enl:

     ; ebx  - unique indices count in this chunk
     ; .b_ptr max cur size - tris_count * 8 bytes
     ; .a_ptr max cur size - tris_count * 16 bytes
     ; whole size both tris_count * 24
     ; in .a_ptr first dword - "old" vert index, next dword
     ; - ptr











  .end:

end if

if 0
;no need - speedy enough single thread version
sort_thread:
; Proc sort 8 byte unit listst using many cores. It pass to
; single thread function params through thread_params global
; variable and through traditionally via ebx.
; Proc uses many stages calling...

;in:
;     esi - table
;     edx - table 8 byte units number



;call_thread1:
; in eax  - proc-th adress
;    edx -  param bitewise 'and' with param passed to proc_th
;    ecx -  max thread count, if -1 no in use


   mov   ecx,[CoresCount]
   mov   ebx,64
   cmp   ecx,ebx
   cmovg ecx,ebx  ; max 64 cores

   push  ecx
   mov   [thread_params],esi
   mov   esi,thread_params+4


   mov   eax,edx
   xor   edx,edx
   div   ecx





   xor   edx,edx
   mov   eax,qsrt_th
   call  call_thread1












qsrt_th:
; in:
;    ebx - thread number
;    dword[thread_params+0] - table each unit 8 bytes  first dword is key
;    dword[thread_params+4+ebx*8] - first
;    dword[thread_params+8+ebx*8] - last


; out:  sorted  part of list, its pointer is in dword[thread_params]
; use merge sort to combine whole list

     mov   esi,thread_params
     add   esi,4
     shl   ebx,3
     add   esi,ebx
     mov   eax,[esi]
     mov   ebx,[esi+4]
     push  eax
     push  ebx
     sub   ebx,eax
     shl   ebx,4

     invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
     or      eax,eax
     jnz     @f
     invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
   @@:
     movd    xmm4,eax    ; mem for stack
                         ; xmm4,5 - proc not used
     pop     ebx
     pop     eax
     movd    xmm5,esp
     movd    esp,xmm4
     movd    xmm7,[thread_params]
     call    qsort_hybrid

     movd    esp,xmm5
     movd    eax,xmm4
     invoke  VirtualFree ,eax,0 , MEM_RELEASE

ret

end if
