check_edit_derv:
; checking in derives of Bezier surfaces edit option,
; if cursor is in 'right' (yellow) place and output
; derives node index
;
; in:
;      eax - cursor position
;      edi - edit buff ptr
; out:
;     eax - index of derives node
;     ecx = 1 - succes, otherwise fail
         push    ebp
         mov     ebp,esp

     .ypos       equ  [ebp-2]
     .xpos       equ  [ebp-4]
     .edit_buff  equ  [ebp-8]

         push    eax
         push    edi

         mov     ebx,[xres_vard]
         add     bx,30  ; 30 - height of line info bar
         movd    xmm0,ebx
         movd    xmm1,eax
         pxor    xmm2,xmm2
         pcmpgtw xmm0,xmm1
         pcmpgtw xmm2,xmm1
         pxor    xmm0,xmm2
         movd    ecx,xmm0
         or      ecx,ecx
         jz      .end
         movzx   edx,ax
         movzx   ebx,[xres_var]
         shr     eax,16  ; y
         sub     eax,30
         imul    eax,ebx
         add     eax,edx
         shl     eax,2
         mov     esi,[screen_ptr]
       ;  mov     esi,edi  ;[edit_buf_ptr]
         add     esi,eax
         cmp     dword[esi],0x00ffff00
       ;  cmp     dword[esi],-1
         jne     .end
         add     edi,eax
         mov     eax,[edi]
         mov     ecx,1
         jmp     .end_ok
   .end:
         xor   eax,eax
         xor   ecx,ecx
   .end_ok:
         mov   esp,ebp
         pop   ebp
ret
edit_init_and_submit:
;in ->  eax = coords y shl 16 + x
;       edx=0 -> init, edx=1 -> submit
;       esi - src
;       edi - dst

    .x_coord               equ ebp-4
    .y_coord               equ ebp-2
    .mx                    equ ebp-40
    .points                equ ebp-80
    .points_rotated_dst    equ ebp-130
    .points_src            equ ebp-134
    .index1                equ ebp-138
    .index2                equ ebp-142
    .index3                equ ebp-146

        push  ebp
        mov   ebp,esp
        sub   esp,155
        ; store both x and y coordinates
        mov    [.points_src],esi
        mov    [.points_rotated_dst],edi

        mov    [.x_coord],eax
        cmp    [edit_flag],2
        je     .face
        cmp    [edit_flag],3
        je     .edge
        or     edx,edx
        jnz    .edit_submit
    macro .check_bar
    {
        movzx  ebx,word[.x_coord]
        movzx  ecx,word[.y_coord]

        movzx  edx,word[xres_var]
        imul   edx,ecx
        add    ebx,edx
        shl    ebx,2
        add    ebx,[edit_buf_ptr]
        mov    ecx,dword[ebx]
        cmp    ecx,-1              ;
    ;    or     ecx,ecx
   ;     and    ebx,0x00ffffff
   ;     cmp    ebx,0x00ff0000 ; is handle bar  ?
    }

        .check_bar
        jz     .end
        inc    ecx    ; prevent long pipe cause ?  ;

        mov    [edit_vertex_no],ecx ;if vert_edit_no = 0, no vertex selected

        mov    eax,dword[.x_coord]
        mov    dword[edit_end_x],eax
        mov    dword[edit_start_x],eax
        jmp    .end
      .edit_submit:
        ; submit both causes long pipe and vertices  edition
        mov    [.x_coord],eax
        .check_bar
        jz     .end
        mov    esi,dword[edit_vertex_no]
        dec    esi
        lea    esi,[esi*3]
        shl    esi,2
        add    esi,[.points_rotated_dst]
        movups   xmm0,[esi]
        movdqu   xmm7,[xxadd]
        cvtdq2ps xmm7,xmm7
        subps    xmm0,xmm7
        movups    [.points],xmm0


       mov   esi,matrix_scaled
       lea   edi,[.mx]
       call  reverse_mx_3x3

       lea   esi,[.points]
       mov   edi,[edit_vertex_no]
       dec   edi       ; prevent long pipe cause ?
       lea   edi,[edi*3]
       shl   edi,2
       add   edi,[.points_src]
       lea   ebx,[.mx]
       mov   ecx,1
       call  rotary
       jmp   .end

   .face:

        or     edx,edx
        jnz    .edit_f_submit
        .check_bar
        jz     .end

;        movups   xword[edit_face_no],xmm0 ;if vert_edit_no = 0, no vertex selected
        mov     dword[edit_face_no],ecx
        mov     eax,dword[.x_coord]
        mov     dword[edit_end_x],eax
        mov     dword[edit_start_x],eax
        jmp     .end
   .edit_f_submit:

        mov    [.x_coord],eax
        .check_bar
        jz     .end
        ;  each triangle takes  edit_buff 4 bytes
        mov    esi,dword[edit_face_no]
        lea    esi,[esi*3]
        shl    esi,2
        add    esi,[triangles_ptr]

        mov    eax,dword[esi+4]
        mov    ebx,dword[esi+8]
        mov    esi,dword[esi]
        lea    esi,[esi*3]
        lea    eax,[eax*3]
        lea    ebx,[ebx*3]
        shl    esi,2
        shl    eax,2
        shl    ebx,2
        mov    [.index1],esi
        mov    [.index2],eax
        mov    [.index3],ebx
        add    esi,[.points_rotated_dst]
        add    eax,[.points_rotated_dst]
        add    ebx,[.points_rotated_dst]

        movups xmm0,[esi]
        movups xmm1,[eax]
        movups xmm2,[ebx]

        movdqu   xmm7,[xxadd]
        cvtdq2ps xmm7,xmm7
        subps    xmm0,xmm7
        subps    xmm1,xmm7
        subps    xmm2,xmm7
        movups   [.points],xmm0
        movups   [.points+12],xmm1
        movups   [.points+24],xmm2

       mov   esi,matrix_scaled
       lea   edi,[.mx]
       call  reverse_mx_3x3

       lea   esi,[.points]
       lea   edi,[.points_rotated_dst]
       lea   ebx,[.mx]
       mov   ecx,3
       call  rotary
       ;scatter from .points_rotated to points_r_ptr
       movups xmm0,[.points_rotated_dst]
       movups xmm1,[.points_rotated_dst+12]
       movups xmm2,[.points_rotated_dst+24]
       mov    eax,[.index1]
       mov    ebx,[.index2]
       mov    ecx,[.index3]
       add    eax,[points_r_ptr]
       add    ebx,[points_r_ptr]
       add    ecx,[points_r_ptr]
       movlps [eax],xmm0
       movlps [ebx],xmm1
       movlps [ecx],xmm2
       movhlps xmm0,xmm0
       movhlps xmm1,xmm1
       movhlps xmm2,xmm2
       movss  [eax+8],xmm0
       movss  [ebx+8],xmm1
       movss  [ecx+8],xmm2
       jmp    .end
  .edge:
        or     edx,edx
        jnz    .edit_e_submit
        .check_bar
        jz     .end

        mov    [edit_edge_no],ecx ;if edit_no = 0, no select
        inc    dword[edit_edge_no]
        mov    eax,dword[.x_coord]
        mov    dword[edit_end_x],eax
        mov    dword[edit_start_x],eax
        jmp    .end

   .edit_e_submit:
        mov    [.x_coord],eax
        .check_bar
        jz     .end
        mov    esi,dword[edit_edge_no]
        dec    esi
        shl    esi,3
        add    esi,[edges_ptr]
        mov    eax,[esi+4]
        mov    esi,[esi]
        lea    esi,[esi*3]
        lea    eax,[eax*3]
        shl    esi,2
        shl    eax,2
        mov    [.index1],esi
        mov    [.index2],eax

        add    esi,[.points_rotated_dst]
        add    eax,[.points_rotated_dst]
        movups xmm0,[esi]
        movups xmm1,[eax]

        movdqu   xmm7,[xxadd]
        cvtdq2ps xmm7,xmm7
        subps    xmm0,xmm7
        subps    xmm1,xmm7
        movups   [.points],xmm0
        movups   [.points+12],xmm1

       mov   esi,matrix_scaled
       lea   edi,[.mx]
       call  reverse_mx_3x3

       lea   esi,[.points]
       lea   edi,[.points_rotated_dst]
       lea   ebx,[.mx]
       mov   ecx,2
       call  rotary
       ;scatter from .points_rotated to points_r_ptr
       movups xmm0,[.points_rotated_dst]
       movups xmm1,[.points_rotated_dst+12]
       mov    eax,[.index1]
       mov    ebx,[.index2]
       add    eax,[points_r_ptr]
       add    ebx,[points_r_ptr]
       movlps [eax],xmm0
       movlps [ebx],xmm1
       movhlps xmm0,xmm0
       movhlps xmm1,xmm1
       movss  [eax+8],xmm0
       movss  [ebx+8],xmm1

   .end:
        mov    esp,ebp
        pop    ebp
ret


write_edit_bars:
    push     ebp
    mov      ebp,esp
    sub      esp,50

    .counter    equ ebp-4
    .x_res4m24  equ ebp-8
    .edge3      equ ebp-20
    .edge2      equ ebp-24
    .edge1      equ ebp-28
    .xresm4     equ ebp-32
    .yresm4     equ ebp-36
    .tri_counter equ ebp-40
    .ed_counter  equ ebp-44

    mov      dword[.counter],0
    movzx    eax,word[xres_var]
    shl      eax,2
    sub      eax,24
    mov      [.x_res4m24],eax
;    mov      [.x_res2m12],eax
    movzx    eax,word[xres_var]
    movzx    ebx,word[yres_var]
    sub      eax,4
    sub      ebx,4
    mov      [.xresm4],eax
    mov      [.yresm4],ebx

    cmp      [edit_flag],2
    je       .edit_face
    cmp      [edit_flag],3
    je       .edit_edge

    mov      esi,[points_rotated_ptr]
  .loop:                ; edit vertex
    push     esi


    cmp      [culling_flag],1
    je       @f
    mov      ebx,[.counter]
    imul     ebx,[i12]
    add      ebx,[points_normals_rotated_ptr]
    bt       dword[ebx+8],31
    jnc       .skip
  @@:

    movups   xmm0,[esi]
    cvtps2dq xmm0,xmm0
;    movdqu   xmm1,[xxadd]
;    paddd    xmm0,xmm1
    movd     eax,xmm0
    psrldq   xmm0,4
    movd     ebx,xmm0
    cmp      eax,4
    jle      .skip
    cmp      ebx,4
    jle      .skip
    cmp      ebx,[.yresm4]
    jge      .skip
    cmp      eax,[.xresm4]
    jge      .skip

    sub      eax,3
    sub      ebx,3
    xchg     eax,ebx
    movzx    edx,[xres_var]
    mul      edx
    add      ebx,eax
    shl      ebx,2
    mov      edi,ebx
    add      edi,[screen_ptr]
    add      ebx,[edit_buf_ptr]
  ;  draw bar 6x6
  @@:
    mov      ecx,6
    mov      edx,dword[.counter]
 .oop:
    push     ecx
    mov      ecx,6
  @@:
    mov      dword[edi],0x00ffff00
    mov      dword[ebx],edx
    add      ebx,4
    add      edi,4
    loop     @b
    add      edi,[.x_res4m24]
    add      ebx,[.x_res4m24]
    pop      ecx
    loop     .oop

  .skip:
    pop     esi
    add     esi,12
    inc     dword[.counter]
    mov     ecx,[.counter]
    cmp     ecx,[points_count_var]
    jng     .loop
    jmp     .end

 .edit_face:
    mov    esi,[triangles_ptr]
    mov    ecx,[triangles_count_var]
    mov    dword[.tri_counter],0
  .loop_face:
    push   esi
    push   ecx
    movd   xmm7,[.tri_counter]   ; xmm7 -> triangle index
    mov    eax,dword[esi]
    shl    eax,2
    lea    eax,[eax*3]
    add    eax,[points_rotated_ptr]
    movups xmm0,[eax]
    mov    eax,dword[esi+4]
    shl    eax,2
    lea    eax,[eax*3]
    add    eax,[points_rotated_ptr]
    movups xmm1,[eax]
    mov    eax,dword[esi+8]
    shl    eax,2
    lea    eax,[eax*3]
    add    eax,[points_rotated_ptr]
    movups xmm2,[eax]
    addps  xmm0,xmm1
    addps  xmm0,xmm2
    mov    eax,3
    cvtsi2ss xmm1,eax
    shufps   xmm1,xmm1,0
    divps    xmm0,xmm1

    cvtps2dq xmm0,xmm0
    movd     eax,xmm0
    psrldq   xmm0,4
    movd     ebx,xmm0
    cmp      eax,4
    jle      .skip_face
    cmp      ebx,4
    jle      .skip_face
    cmp      ebx,[.yresm4]
    jge      .skip_face
    cmp      eax,[.xresm4]
    jge      .skip_face

    sub      eax,3
    sub      ebx,3
    xchg     eax,ebx
    movzx    edx,[xres_var]
    mul      edx
    add      ebx,eax
    shl      ebx,2
    lea      edi,[ebx]
    add      edi,[screen_ptr]
    add      ebx,[edit_buf_ptr]
  ;  movhlps  xmm6,xmm7
  ;  draw bar 6x6
  @@:
    mov      ecx,6
    ;      xmm7 - > counter
 .oop_f:
    push     ecx
    mov      ecx,6
  @@:
    mov      dword[edi],0x00ffff00
    movd     [ebx],xmm7
  ;  movd     [ebx+8],xmm6
    add      ebx,4
    add      edi,4
    loop     @b
    add      edi,[.x_res4m24]
    add      ebx,[.x_res4m24]
    pop      ecx
    loop     .oop_f

  .skip_face:
    pop     ecx
    pop     esi
    add     esi,12
    add     dword[.tri_counter],1   ; triangle index
    dec     ecx
    jnz     .loop_face
    jmp     .end

  .edit_edge:
    mov    dword [.ed_counter],0
    mov    esi,[edges_ptr]  ; each edge 2 dwords
    mov    ecx,[edges_count]
  .loop_edge:
    push   esi
    push   ecx

    mov    eax,dword[esi]
    shl    eax,2
    lea    eax,[eax*3]
    add    eax,[points_rotated_ptr]
    movups xmm0,[eax]
    mov    eax,dword[esi+4]
    shl    eax,2
    lea    eax,[eax*3]
    add    eax,[points_rotated_ptr]
    movups xmm1,[eax]

    addps  xmm0,xmm1
    divps  xmm0,[f2x4]


    mov      ecx,[.ed_counter] ;[.edge1]
    mov      edx,[.xresm4]
    mov      esi,[.yresm4]
    mov      eax,0x00ffff00
    call     bar_edge1




  .skip_edge:
    pop     ecx
    pop     esi
    add     esi,8
    add     dword [.ed_counter],1
    dec     ecx
    jnz     .loop_edge

  .end:
    mov     esp,ebp
    pop     ebp
ret

bar_edge1:
 ;  ecx - edge index; signature
 ;  xmm0 - coordinates
 ;  eax - color
 ;  edx  - xresm4
 ;  esi  - yresm4
    push     ebp
    mov      ebp,esp

    .xresm4   equ ebp-4
    .yresm4   equ ebp-8
    .ed       equ ebp-12
    .col      equ ebp-16
    .add      equ ebp-20

    push     edx
    push     esi
    push     ecx
    push     eax
    movzx    eax,[xres_var]
    sub      eax,6
    shl      eax,2
    push     eax

    cvtps2dq xmm0,xmm0
    mov      eax,5
    movdqa   xmm1,xmm0
    movdqa   xmm2,xmm0
    movdqu   xmm3,[.yresm4]
    movd     xmm4,eax
    pshufd   xmm3,xmm3,11100001b
    pshufd   xmm4,xmm4,0
    pcmpgtd  xmm1,xmm3
    pcmpgtd  xmm2,xmm4
    pxor     xmm1,xmm2
    pmovmskb eax,xmm1
    cmp      al,-1
    jne      .skip

    movd     eax,xmm0
    psrldq   xmm0,4
    movd     ebx,xmm0
;    cmp      eax,5
;    jle      .skip
;    cmp      ebx,5
;    jle      .skip
;    cmp      ebx,dword[.yresm4]
;    jge      .skip
;    cmp      eax,dword[.xresm4]
;    jge      .skip


    sub      eax,3
    sub      ebx,3
    xchg     eax,ebx
    movzx    edx,[xres_var]
    mul      edx
    add      ebx,eax
    shl      ebx,2
    mov      edi,ebx
    add      edi,[screen_ptr]
    add      ebx,[edit_buf_ptr]
    mov      edx,dword[.ed]
  ;  draw bar 6x6
    mov      ecx,6
    mov      eax,[.col]
 .oop_ed:
    push     ecx
    mov      ecx,6
  @@:
    mov      dword[edi],eax
    mov      [ebx],edx
    add      ebx,4
    add      edi,4
    loop     @b
    add      edi,[.add]
    add      ebx,[.add]
    pop      ecx
    loop     .oop_ed
  .skip:
   mov       esp,ebp
   pop       ebp
ret

clear_edit_buf:
;    xor   eax,eax          ; clear
    mov   eax,-1         ;
    mov   edi,[edit_buf_ptr]
    movzx ebx,[xres_var]           
    movzx ecx,[yres_var]           
    imul  ecx,ebx
    call  fill_aligned


ret

write_edit_bars_vert:
; this proc used for vertices edit module and for closed
; series Bezier curves edit module (many "sticked" pipes).
;in:
;   eax - x resolution of image
;   ebx - y resolution of image
;   esi - ptr vertices to display
;   ecx - count vertices to display
;   edi - ptr to edit buffer
;   edx - ptr to screen buffer normal
;   xmm0 = 1 - bezier patch bars cause, otherwise - normal vert

    push     ebp
    mov      ebp,esp
    sub      esp,64

    .counter     equ ebp-4
    .x_res4m24   equ ebp-8
    .bez_patch_c equ ebp-12
    .yresm4     equ ebp-32
    .xresm4     equ ebp-36
    .yres       equ ebp-40
    .xres       equ ebp-44
    .vert_ptr   equ ebp-48
    .vert_count equ ebp-52
    .edit_b_ptr equ ebp-56
    .scr_ptr    equ ebp-60

    mov      [.xres],eax
    mov      [.yres],ebx
    mov      [.vert_count],ecx
    mov      [.scr_ptr],edx
    mov      [.vert_ptr],esi
    mov      [.edit_b_ptr],edi
    movd     [.bez_patch_c],xmm0

    mov      dword[.counter],0
    shl      eax,2
    sub      eax,24
    mov      [.x_res4m24],eax
    mov      eax,[.xres]
;    mov      ebx,[.yres]
    sub      eax,4
    sub      ebx,4
    mov      [.xresm4],eax
    mov      [.yresm4],ebx

    mov      esi,[.vert_ptr]
  .loop:
    push     esi
    movups   xmm0,[esi]
    movapd   xmm1,[i4x4]
    cvtps2dq xmm0,xmm0
    movq     xmm2,[.xresm4]
    pcmpgtd  xmm1,xmm0
    pcmpgtd  xmm2,xmm0
    pxor     xmm1,xmm2
    pmovmskb eax,xmm1
    cmp      al,0xff
    jnz       .skip
    movd      ebx,xmm0
    psrldq    xmm0,4
    movd      eax,xmm0

    sub      eax,3
    sub      ebx,3
    mov      edx,[.xres]
    mul      edx
    add      ebx,eax
    shl      ebx,2
    mov      edi,ebx
    add      edi,[.scr_ptr]
    add      ebx,[.edit_b_ptr]
  ;  draw bar 6x6
  @@:
    mov      ecx,6
    mov      edx,dword[.counter]
 .oop:
    push     ecx
    mov      ecx,6
  @@:
    mov      dword[edi],0x00ffff00
    mov      dword[ebx],edx
    add      ebx,4   ;2
    add      edi,4
    sub      ecx,1
    jnz      @b

    add      edi,[.x_res4m24]
    add      ebx,[.x_res4m24]  ; .x_res2m12
    pop      ecx
    sub      ecx,1
    jnz      .oop

  .skip:
    pop     esi
    add     esi,12
    add     dword[.counter],1
    mov     ecx,[.counter]
    cmp     ecx,[.vert_count]
    jng     .loop

    mov     esp,ebp
    pop     ebp
ret